// ClipLine.h  version 1.0
// object shell representing a line and consisting of two vectors.
// to be used mainly as a temporary object for line clipping algorithm.
#ifndef _CLIPLINE_H
#define _CLIPLINE_H

#include "commdefs.h"
#include "matrix.h"
#include "point.h"
#include <assert.h>

class ClipLine {
friend polygon;
public:
inline  ClipLine();
inline	ClipLine(const vector&,const vector&); // construct line from endpoints.
inline	ClipLine(const point&,const point&);   // construct line from point obj.s

inline vector& operator[](int);	// returns either endpoint 0, or 1.
inline vector  operator[](int) const;

inline float& p0(int i){ if(i==0){ return endpoint0[0];};
			 return(endpoint0[1]); };

inline float& p1(int i){ if(i==0){ return endpoint1[0];};
			 return(endpoint1[1]); };

inline vector& p0(void){ return endpoint0; };
inline vector& p1(void){ return endpoint1; };
inline ClipLine& operator=(const ClipLine&);

// initialization function:
inline void Initialize(const vector&,const vector&);

// true value of 'accept' means line is visible ( within clip rect.)
BOOLEAN accept;	// default value is FALSE ( assumed to be not visible ).

// if object is a clipping boundary , this variable indicates which one:
unsigned char clipExtreme;

private:
	vector endpoint0;	// internal representation of endpoints.
	vector endpoint1;
};

#endif