#include "fileio.h"
// Gregory Ecker
// Graphics Programming
// Prof. Velho
// 8/7/94
// version 1.5 -- graph objects added 8/14
// file input / output functions defined:

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
// readgraphfiledata: reads a single graph object from file.
//   allocate all memory for the graph object according to parameters
//   specified in file.
//   ASSUMES memory has not been allocated for graph object.

void ReadGraphFileData3dv(FILE* filehandle,graph* curgraph,int curpoints){
   int cur_edges;
   vector *curVertex;
  // temporary variable to read scalars from file:
  // W automatically initialized to 1.
     float x,y,z;

   for(int j=0;j<curpoints;j++){
	 // read data for new vertex.
	   if (fscanf(filehandle, "%e", &x)){
		}
	   else {
		printf("Error reading an float from file.\n");
		exit(1);
	      };
	   if (fscanf(filehandle, "%e", &y)){
		}
	   else {
		printf("Error reading an float from file.\n");
		exit(1);
	      };
	   if (fscanf(filehandle, "%e", &z)){
		}
	   else {
		printf("Error reading an float from file.\n");
		exit(1);
	      };
	curVertex = new vector(x,y,z,1);
	curgraph->Insert_pt(curVertex,j);
     }   // end for - all vertices read and allocated
  // read all edges from file + allocate space for edge array elt.s
  int from,to,last;
  edge *cur_edge;
  if (fscanf(filehandle, "%i", &cur_edges)){
		}
	   else {
		printf("Error reading an int from file.\n");
		exit(1);
	      };
   curgraph->enlarge_edge_array_to(cur_edges);
   int index=0;
   for(int i=0;i<cur_edges;i++){
    // read 'from' + 'to' fields for each edge:
     if (fscanf(filehandle, "%i", &from)){
		}
	   else {
		printf("Error reading an integer from file.\n");
		exit(1);
	      };
     if (fscanf(filehandle, "%i", &to)){
		}
	   else {
		printf("Error reading an integer from file.\n");
		exit(1);
	      };

  // if the 1st variable is 0, it indicates a jump to a new point number.
  // otherwise it indicates a line draw to the new location.
   if(to == 0){
       last=from;
     //  cur_edge->from=-1;  // null drawing edge
     //  cur_edge->to=-1;
     //  curgraph->Insert_edge(cur_edge,i);
     } else {
     // allocate space for new edge:
       cur_edge = new edge;
       cur_edge->color=to;
       cur_edge->from=last-1;
       cur_edge->to=from-1;
       curgraph->Insert_edge(cur_edge,index);
       index++;
       last=from;
     }
   };

  curgraph->colored=TRUE;
  curgraph->initialized=TRUE;
  curgraph->Tx=320;
  curgraph->Ty=200;
};

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
// ReadPolygonList:
//	reads all polygon-point data into PolyList (list of polygons)
//      allocates memory for all polygons + the list of polygons

void ReadPolygonList(FILE* fileHandle,polygon** PolyList,int& numPoly){
 polygon *curPoly;

// read data for all polygons into the polygon** PolyList
 for(int i=0;i<numPoly;i++){
  // allocate mem for new polygon:
    curPoly  = new polygon;
 // read in file data into polygon.
  ReadPolyFileData(fileHandle,curPoly);
    PolyList[i]=curPoly;
   };

// display all polygon data:
 if(DISPLAY_DATA){
  for(int j=0;j<numPoly;j++){
     DisplayPolyData(PolyList[0]);
    };
   }
};

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
// ReadNumPolygons:
//	reads from the data file pointed to by 'filehandle', the number
// 	of polygons contained within the scene file (datafile).
//	MUST be called first on all datafiles.

int ReadNumPolygons(FILE* filehandle){
    int curpoly;
	// read number of polygons to be read:
	if(fscanf(filehandle, "%i", &curpoly)){
		printf("%i polygons in scene \n",curpoly);
		} else {
	   printf(" error reading number of polygons (int) from file.");
	}
    return curpoly;
}; // end ReadNumPolygons

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
// OpenDataFile:
//      associates a filehandle with a filename, and opens it in the
//	apropriate mode (given by #defines in 'commdefs.h')
//
FILE* OpenDataFile(FILE* filehandle,const char* filename,const char* mode){
// INFILENAME, "rt"
   if((filehandle = fopen(filename,mode))==NULL){
	printf("error opening %s, try again \n:",filename);
	return NULL;
      };
   return(filehandle);
};

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
// ReadPolyFileData:
//	Reads data from file (*filehandle) into polygon pointed to by
//	'*curpoly'.
// 	ASSSUMES memory has already been allocated for this polygon.
//
void ReadPolyFileData(FILE *filehandle,polygon *curpoly){
   point *curPoint;
   int curpoints,PolyTx,PolyTy;
   float f;
 // read number of points to be read into polygon:
 if(fscanf(filehandle, "%i", &curpoints)){
   printf("%i points in polygon \n",curpoints);
  } else {
   printf(" error reading number of points (int) from file.");
  }
 // read each of the points into the polygon.
 for(int j=0;j<curpoints;j++){
  // allocate space for new point:
  curPoint = new point;
      for(int i=0;i<4;i++){
	 // read data into new point.
	   if (fscanf(filehandle, "%e", &f)){
		curPoint->operator[](i)=f;
		}
	   else {
		printf("Error reading an float from file.\n");
		exit(1);
	      }
       } // end for - entry into point data
    // insert new Point into polygon:
	curpoly->Insert(*curPoint);
  } // end polygon points for
 // read screen offsets
 // read x offset
  if(fscanf(filehandle, "%i", &PolyTx)){
   printf(" x screen offset : %i \n",PolyTx);
  } else {
   printf(" error reading x-screen offset (int) from file.");
  }
  curpoly->Tx=PolyTx;
 // read y offset
  if(fscanf(filehandle, "%i", &PolyTy)){
   printf(" y screen offset : %i \n",PolyTy);
  } else {
   printf(" error reading y-screen offset (int) from file.");
  }
  curpoly->Ty=PolyTy;
}; // end ReadPolyFileData

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
// Display poly data:
//	displays defining components of all points within given polygon.
//
void DisplayPolyData(polygon* poly){
 point *curPoint;
 int pointNum=1;
	  // set curPoint to head of poly point list:
	    curPoint=poly->Head();

	 while(curPoint != NULL){
	  // display data within new point object:
	   printf("\n point number %i \n",pointNum);
	   for(int i=0;i<4;i++){
	       switch(i){
		case 0 :{ printf("%6.2f  ",curPoint->x());
			  break; }
		case 1 :{ printf("%6.2f  ",curPoint->y());
			  break; }
		case 2 :{ printf("%6.2f  ",curPoint->z());
			  break; }
		case 3 :{ printf("%6.2f  ",curPoint->W());
			  break; }
	       }; // end switch
	   }; // end display point scalars
	   pointNum++;
	   curPoint=curPoint->Next();
	}; //end while
	printf("\n x offset : %i",poly->Tx);
	printf("\n y offset : %i",poly->Ty);
}; // end DisplayPolyData
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////