; Greg Ecker
; Computer Systems Org II
; Prof. Goldberg
;
; Assembly language routines to manipulate the mouse,
; and to be called from .cpp files.
  .MODEL large

PUBLIC _showsite
PUBLIC _hidesite
PUBLIC _setsite
PUBLIC _initmouse
PUBLIC _Setsight
PUBLIC _SetVerBound
PUBLIC _SetHorBound
PUBLIC _ResetMouse
PUBLIC _SetMousePos
; PUBLIC _pollsite

  .STACK
;
; variables:
  .DATA
;siteX          dw      ?        ; mouse x-coordinate.
;siteY          dw      ?        ; mouse y-coordinate.
;buttons	       dw      ?	; mouse-button info.

; information on size,shape of mouse cursor:

;sights
;	 dw      1111 1111 1111 1111 b     0xFFFF
;	 dw      1111 1111 1111 1111 b     0xFFFF
;	 dw      1111 1111 1111 1111 b     0xFFFF
;	 dw      1100 1111 1111 0011 b     0xCFF3
;	 dw      1110 0111 1110 0111 b     0xE7E7
;	 dw      1111 0011 1100 1111 b     0xF3CF
;	 dw      1111 1001 1001 1111 b     0xF99F
;	 dw      1111 1100 0011 1111 b     0xFC3F
;	 dw      1111 1100 0011 1111 b     0xFC3F
;	 dw      1111 1001 1001 1111 b     0xF99F
;	 dw      1111 0011 1100 1111 b     0xF3CF
;	 dw      1110 0111 1110 0111 b     0xE7E7
;	 dw      1100 1111 1111 0011 b     0xCFF3
;	 dw      1111 1111 1111 1111 b     0xFFFF
;	 dw      1111 1111 1111 1111 b     0xFFFF
;	 dw      1111 1111 1111 1111 b     0xFFFF
;
;	 dw      1110 1000 0001 0111 b     0xE817
;	 dw      1000 0100 0010 0001 b     0x8421
;	 dw      1000 0011 1100 0001 b     0x83C1
;	 dw      0011 0000 0000 1100 b     0x300C
;	 dw      0001 1000 0001 1000 b     0x1818
;	 dw      0000 1100 0011 0000 b     0x0C30
;	 dw      1000 0110 0110 0001 b     0x8661
;	 dw      0100 0011 1100 0010 b     0x43C2
;	 dw      0100 0011 1100 0010 b     0x43C2
;	 dw      1000 0110 0110 0001 b     0x8661
;	 dw      0000 1100 0011 0000 b     0x0C30
;	 dw      0001 1000 0001 1000 b     0x1818
;	 dw      0011 0000 0000 1100 b     0x300C
;	 dw      1000 0011 1100 0001 b     0x83C1
;	 dw      1000 0100 0010 0001 b     0x8421
;	 dw      1110 1000 0001 0111 b     0xE817
;
;sightcursor
;		 dw  1111 1111 1111 1111 b ;    0xFFFF
;		 dw  1011 1111 1111 1101 b ;    0xBFFD
;		 dw  1101 1111 1111 1011 b ;    0xDFFB
;		 dw  1110 1111 1111 0111 b ;    0xEFF7
;		 dw  1111 0111 1110 1111 b ;    0xF7EF
;		 dw  1111 1011 1101 1111 b ;    0xFBDF
;		 dw  1111 1101 1011 1111 b ;    0xFDBF
;		 dw  1111 1110 0111 1111 b ;    0xFE7F
;		 dw  1111 1110 0111 1111 b ;    0xFE7F
;		 dw  1111 1101 1011 1111 b ;    0xFDBF
;		 dw  1111 1011 1101 1111 b ;    0xFBDF
;		 dw  1111 0111 1110 1111 b ;    0xF7EF
;		 dw  1110 1111 1111 0111 b ;    0xEFF7
;		 dw  1101 1111 1111 1011 b ;    0xDFFD
;		 dw  1011 1111 1111 1101 b ;    0xBFFD
;		 dw  1111 1111 1111 1111 b ;    0xFFFF
;
	.code
;**************************************************************************
;**************************************************************************
; set button state variables according to mouse condition + position.
; from c++:
;
;extern "C" void pollsite(unsigned siteY,unsigned siteX,unsigned buttons);
;_pollsite    Proc
;    ARG siteX : WORD, siteY : WORD, buttons : WORD
;	push bp
;	mov  bp,sp
;	push bx
;	push cx
;	push dx
;
;	mov  ax,3       ; get mouse button + position.
;	Int  33H
;	mov  es:[siteX],CX
;	mov  es:[siteY],DX
;	mov  es:[buttons],BX
;
;	pop dx
;	pop cx
;	pop bx
;
;	pop bp
;	RET
;_pollsite    endp
;**************************************************************************
;**************************************************************************
; show the mouse at it's current position.
; extern "C" void showsite();

_showsite    Proc

;	 Push   bp
;	 mov    bp,sp

;	 Push   ax          ; save registers.
;	 Push   cx
;	 Push   dx

	 Mov     Ax,1        ; Function 1 shows the mouse
	 Int     33H
								; restore registers.
;	 pop    dx
;	 Pop    cx
;	 Pop    ax

;	 mov    sp,bp
;	 pop	  bp

	 RET
_showsite    endp
;
;***************************************************************************
;***************************************************************************
; Proc. hidesite
; void extern "C" hidesight();

_hidesite        proc
;	 push		bp
;	 mov		bp,sp

;	 push    ax
;	 push    cx
;	 push    dx

	 mov     ax, 2          ; service 2 hides the mouse.
	 int     33h

;	 pop     dx
;	 pop     cx
;	 pop     ax

;	 mov		sp,bp
;	 pop		bp

	 ret
_hidesite endp
;
;****************************************************************************
;****************************************************************************
; the following proc sets the mouse coordinates according to site_x, site_y
;

_setsite     Proc
 ARG site_y:WORD,site_x:WORD
	 push		bp
	 mov		bp,sp

	 push    ax
	 Push    cx
	 Push    dx

	 Mov     cx,site_Y
	 Mov     dx,site_X
	 Mov     ax, 4        ; Function four sets the Mouse coordinates
	 Int     33H

	 Pop     dx
	 Pop     cx
	 pop     ax

	 mov		sp,bp
	 pop		bp
	 RET
_setsite     endp
;
;***************************************************************************
;***************************************************************************
; the following routine initializes mouse
; with no special attributes :  carry flag set if there was a problem.
; extern "C" void initmouse();

_initmouse proc
;	  push	bp
;	  mov		bp,sp

	  mov   ax, 0
	  int   33h

;	  clc
;	  cmp   ax, 0           ; error in intiailization ?
;	  jne   fin
;	  stc
;	  mov	  sp,bp
;	  pop   bp

	  ret
_initmouse endp

;***************************************************************************
;***************************************************************************
; Following procedure sets the mouse to look like a site .
; All registers maintained on the stack.
; parameters:
;	 segment containing array "sights" (16 bit)
;        offset  of array "sights" (16 bit)
; declaration from c++ -
; extern "C" void Setsight(unsigned int segment,unsigned int offset);

_Setsight  Proc
ARG	segsights:WORD,offsights:WORD

	 push	  bp
	 mov    bp,sp

	 push   ax
	 push   bx
	 push   cx
	 push   dx
	 push   es
	 push   ds

	 Mov     ax,9        ; Function 9 sets the Mouse graphics
	 Mov     bx,8
	 Mov     cx,8

	 mov		dx,segsights
	 mov     es,dx

	 mov     dx,offsights
	 Int     33h

	 pop     ds
	 pop     es
	 pop     dx
	 pop     cx
	 pop     bx
	 pop     ax

	 mov		sp,bp
	 pop		bp
	 RET
_Setsight    endp
;
;************************************************************************
;*************************************************************************
;

_SetVerBound  Proc
	 push		bp
	 mov		bp,sp

	 Mov     Ax,8        ; Function Eight sets the Mouse coordinates
	 Mov     Cx,0
	 Mov     Dx,500
	 Int     33H

	 mov		sp,bp
	 pop		bp
	 RET
_SetVerBound  endp
;*************************************************************************
; sets horizontal range of cursor
; extern "C" void SetHorBound(void);
_SetHorBound  Proc
      ;	 push		bp
      ;	 mov		bp,sp
	 push cx
	 push dx

	 Mov     Ax,7        ; Function Seven sets the Mouse coordinates
	 Mov     Cx,0        ; minimum column
	 Mov     Dx,100      ; maximum column
	 Int     33H

	 pop dx
	 pop cx

      ;	 mov		sp,bp
      ;	 pop		bp
	 RET
_SetHorBound  endp
;
;***************************************************************************
;*************************************************************************

_ResetMouse    Proc

	 push    bp
	 mov		bp,sp

	 Xor     Ax,Ax
	 Int     33H

	 mov		sp,bp
	 pop		bp

	 RET
_ResetMouse    endp
;*************************************************************************
; set mouse position to 50,300
_SetMousePos   Proc
	push   cx
	push   dx

	mov    cx,50
	mov    dx,300

	mov    ax,4
	Int    33H

	pop    dx
	pop    cx
_SetMousePos   endp
END

